function [trackError, overLap, gtPos] = calcError(imgdat, targetPos, fr)

global opts gt

% load the groundtruth image
gtPos = gt(fr, :);

[imgHeight, imgWidth, ~] = size(imgdat);

if(opts.rotateMode)
    [X, Y] = meshgrid(1:imgWidth, 1:imgHeight);
    xv = gtPos(1:2:end);
    xv = [xv xv(1)];
    yv = gtPos(2:2:end);
    yv = [yv yv(1)];
    realout = inpolygon(X, Y, xv, yv);
    realPos = [mean(xv(1:4)), mean(yv(1:4))];

    xv = targetPos(1:2:end);
    xv = [xv xv(1)];
    yv = targetPos(2:2:end);
    yv = [yv yv(1)];
    output = inpolygon(X, Y, xv, yv);    
    ourPos = [mean(xv(1:4)), mean(yv(1:4))];
else    
    left = max(1,gtPos(1));
    top = max(1,gtPos(2));        
    right = min(imgWidth, gtPos(1) + gtPos(3) - 1);
    down = min(imgHeight, gtPos(2) + gtPos(4) - 1);
    gtPos(3) = right;
    gtPos(4) = down;
  
    realout = zeros(imgHeight, imgWidth);
    realout(top:down,left:right) = 1;    
    realout = realout > 0;
    realPos = [left+right, top+down]/2;
    targetPos = round(targetPos);    
    output = zeros(imgHeight, imgWidth);
    output(max(1,targetPos(2)):min(imgHeight, targetPos(2)+targetPos(4)-1),max(1,targetPos(1)):min(imgWidth, targetPos(1)+targetPos(3)-1)) = 1;
    output = output > 0;  
    ourPos = [targetPos(1) + targetPos(3)/2, targetPos(2) + targetPos(4)/2];
end

% calculate the pixel error
trackError = sqrt(sum((ourPos-realPos).^2));
% calculate the intersect-to-union ratio 
interArea = realout & output;
unionArea = realout | output;
overLap = nnz(interArea)/nnz(unionArea);
overLap = overLap*100;