function [affPotential, partNeighbors] = calcAffPotentialCost(canFeat, canPos, targetStructModel, nNodes, nLabels)

global opts

affPotential = zeros(nLabels, nNodes);
partNeighbors = [];

for i = 1:nNodes
    for j = 2:nLabels
        partFeat = targetStructModel.partFeat(j-1,:);
        partPos = targetStructModel.partPos(j-1,:);
        if(norm(partPos-canPos(i,:))<=3*opts.spSize)
            partNeighbors = cat(1, partNeighbors, [j-1, i, partPos, canPos(i,:)]);
            affPotential(j,i) = calcX2Dist(partFeat, canFeat(i,:));
        else
            affPotential(j,i) = 20*calcX2Dist(partFeat, canFeat(i,:));
        end
    end
end