function [colorFeat, c_bins] = calcColorFeat(img, mask, label)

global opts

nFeat = numel(label);
nHBins = opts.nHBins;
nSBins = opts.nSBins;
nVBins = opts.nVBins;
maxBins = nHBins*nSBins*nVBins;
colorFeat = zeros(maxBins, nFeat);  
% c_bins(i,j) is the histogram value index of a pixel
img = rgb2hsi(img);
hd = min(fix((img(:,:,1)*nHBins)), nHBins-1);
sd = min(fix((img(:,:,2)*nSBins)), nSBins-1);
vd = min(fix((img(:,:,3)*nVBins)), nVBins-1);
c_bins = vd*nHBins*nSBins + sd*nHBins + hd + 1;
% calculate the color histogram
t = tabulate(mask(:));
sp_pixel_num = t(:,2);
num = 0;
for k = 1:length(sp_pixel_num)
    x = min(maxBins, c_bins(mask == k));
    %% count freq
    if(~isempty(x))
        num = num + 1;
        x = sort(x);
        frx = diff(x);
        frx = frx(:);
        frx(end + 1) = 1; 
        frx = find(frx);
        frx = frx(:);
        value = x(frx);
        frx = [0; frx]; 
        freq = diff(frx); 
        colorFeat(value, num) =  freq/max(1,sp_pixel_num(k));
    end
end
colorFeat = colorFeat ./ repmat(sum(colorFeat,1), size(colorFeat,1), 1);
colorFeat = colorFeat';
% calculate color bins value
nHBins = 16;
nSBins = 16;
nVBins = 16;
maxBins = nHBins*nSBins*nVBins;
hd = min(fix((img(:,:,1)*nHBins)), nHBins-1);
sd = min(fix((img(:,:,2)*nSBins)), nSBins-1);
vd = min(fix((img(:,:,3)*nVBins)), nVBins-1);
c_bins = min(maxBins, vd*nHBins*nSBins + sd*nHBins + hd + 1);