function [model, accuracy] = calcDisModel(posFeat, negFeat, cValue)

global opts

if(nargin == 2)
    options.c = opts.svmC;
else
    options.c = cValue;
end

% discriminative model
allFeat = cat(1, posFeat, negFeat);
N = size(allFeat, 1);
options.lambda                     = 1/(options.c*N);
options.B                          = 1;
options.l1loss                     = 0;
options.max_ite                    = 1000;
options.wp                         = 1;
options.wn                         = 1;
options.eps                        = 0.1;
options.tolPG                      = 1.0e-12;
options.nbite                      = 30*N;
options.reguperiod                 = 10;
options.seed                       = 1234543;
options.num_threads                = -1;
allLabel = cat(2, ones(1, size(posFeat, 1)), -1*ones(1, size(negFeat, 1)));
model = cddcsvm_train(allFeat', allLabel, options);
btrain = model(end);
wtrain = model(1:end-1);
fxtrain = wtrain'*allFeat' + btrain;
flabel = sign(fxtrain);
accuracy = nnz(allLabel==flabel)/numel(allLabel);
if(accuracy>=0.99)
%     disp(['acc = ' num2str(accuracy)]);
    opts.fusionWeight = 0.6;
end