function E = calcLabelingEnergy(Dcost, labeling, Scost, neighbors)

[nLabels, nPoints] = size(Dcost);
h = GCO_Create(nPoints, nLabels);

% input the data term
GCO_SetDataCost(h, (Dcost));
% input the smooth term
if(nargin==4)
    GCO_SetSmoothCost(h, Scost);
    GCO_SetNeighbors(h, neighbors);
end
% input the labeling
GCO_SetLabeling(h, labeling);
% calculate the energy of current labeling
E = GCO_ComputeEnergy(h);
GCO_Delete(h);