function structPotential = calcStructPotentialCost(partNeighbors, nNodes)

global opts

structPotential = zeros(nNodes);
if(~isempty(partNeighbors))
    partPos = partNeighbors(:,3:4);
    canPos = partNeighbors(:,5:6);
    partDist = pdist2(partPos, partPos);
    canDist = pdist2(canPos, canPos);
    allNeighborNodes = and(partDist>0 & partDist<=2*opts.spSize, canDist>0 & canDist<=2*opts.spSize); % find the neighboring relations

    for i = 1:size(partNeighbors,1)
        canMatch = find(allNeighborNodes(i,:));
        for k = 1:numel(canMatch)
            j = canMatch(k);
            x1 = partPos(i, 1) - partPos(j, 1);
            y1 = partPos(i, 2) - partPos(j, 2);
            x2 = canPos(i, 1) - canPos(j, 1);
            y2 = canPos(i, 2) - canPos(j, 2);    
            geoDist = sqrt((x1-x2)^2 + (y1-y2)^2);
            if(geoDist <= 3*opts.spSize)
                structPotential(partNeighbors(i,2),partNeighbors(j,2)) = exp(-geoDist/opts.spSize);
            end    
        end
    end
end