function [targetProposalCost, Smoothness, foreScore] = calcTargetProposalCost(curSegment, targetProposalModel, nNodes, nLabels)

global opts

% evidence of superpixels
genData = calcGenDataCost(curSegment.spLabels.searchSpLabel, curSegment.spLabels.c_bins, targetProposalModel.genModel, nNodes, nLabels); % generative cost
[disData, foreScore] = calcDisDataCost(curSegment.spFeature.spSearchFeature, targetProposalModel.disModel, nNodes, nLabels); % discriminative cost
foreScore = (foreScore + (genData(1,:)-genData(2,:)))/2;
foreScore = 1./(1+exp(-foreScore));

targetProposalCost = opts.segGenWeight*genData + opts.segDisWeight*disData;

%% calculate the smooth term
Smoothness = ones(nLabels, nLabels);
Smoothness = Smoothness - diag(diag(Smoothness));