function genModel = initGenModels(img, spLabel, posLabel, negLabel)

global opts

nHBins = 16;
nSBins = 16;
nVBins = 16;
maxBins = nHBins*nSBins*nVBins;
genModel.foreModel = zeros(1, maxBins);
genModel.backModel = zeros(1, maxBins);
hsvimg = rgb2hsi(img);
hd = min(fix((hsvimg(:,:,1)*nHBins)), nHBins-1);
sd = min(fix((hsvimg(:,:,2)*nSBins)), nSBins-1);
vd = min(fix((hsvimg(:,:,3)*nVBins)), nVBins-1);
c_bins = vd*nHBins*nSBins + sd*nHBins + hd + 1;
opts.maxBins = maxBins;

genModel.foreModel = updateGenModel(c_bins, spLabel, find(posLabel));
genModel.backModel = updateGenModel(c_bins, spLabel, find(negLabel));

opts.initForeModel = genModel.foreModel;
opts.initBackModel = genModel.backModel;

% normalization of the histogram
genModel.foreModel = genModel.foreModel/sum(genModel.foreModel);   
genModel.backModel = genModel.backModel/sum(genModel.backModel);   

genModel.foreModel(genModel.foreModel==0) = min(0.0001, min(genModel.foreModel(genModel.foreModel>0))/2);
genModel.backModel(genModel.backModel==0) = min(0.0001, min(genModel.backModel(genModel.backModel>0))/2);