function [targetStructModel, partLabel, spConf] = initTargetStructModel(searchImage, searchPos, targetProposalModel, spLabels, spFeature, posLabel)

spLabel = spLabels.searchSpLabel;
[height, width] = size(spLabel);
% generate coarse target parts
[segLabel, spConf] = initTargetParts(searchImage, spLabels, spFeature, targetProposalModel);

% calculate the structure model
if(nnz(segLabel))
    partLabel = find(and(posLabel, segLabel));
else
    partLabel = find(posLabel);
end
[~, targetStructModel.partPos] = calcPartPos(spLabel, partLabel, searchPos);
targetStructModel.partVector = repmat([width, height]/2, [size(targetStructModel.partPos,1), 1]) - targetStructModel.partPos;
targetStructModel.partFeat = spFeature.spSearchFeature(partLabel,:);
targetStructModel.partConf = spConf(partLabel);
targetStructModel.numParts = numel(partLabel);
targetStructModel.numFrPartTrack = ones(1,targetStructModel.numParts);