function [targetState, frSegment, models] = initTracker(imgdat, region)

global runTime
timeStart = clock;   
%% initialize target appearance model
[searchImage, searchPos, targetState, targetAppModel] = initTargetAppModel(imgdat, region);

%% initialize target proposal model
[targetProposalModel, spLabels, spFeature, posLabel] = initTargetPropoalModel(targetState, searchImage, searchPos, targetAppModel);

%% initialize target structure model
[targetStructModel, partLabel, spConf] = initTargetStructModel(searchImage, searchPos, targetProposalModel, spLabels, spFeature, posLabel);

%% initialize frame segment
frSegment = initFrSegment(spLabels, spFeature, partLabel, spConf);

models.targetAppModel = targetAppModel;
models.targetProposalModel = targetProposalModel;
models.targetStructModel = targetStructModel;
runTime(1) = etime(clock, timeStart);

%% show the annotated target
% displayTrackingResult(imgdat, targetState, searchPos, 1, 1);

%% show candidate parts
% showCandidateParts(searchImage, spLabels.searchSpLabel, partLabel, [], 1, 1);