function cfResponse = calcCfResponse(searchImage, targetAppModel)

% compute feature map
xt = getFeatureMap(searchImage, targetAppModel.cf_response_size, targetAppModel.hog_cell_size);
% apply Hann window
xt_windowed = bsxfun(@times, targetAppModel.hann_window, xt);
% compute FFT
xtf = fft2(xt_windowed);
% Correlation between filter and test patch gives the response
% Solve diagonal system per pixel.
hf = bsxfun(@rdivide, targetAppModel.hf_num, sum(targetAppModel.hf_den, 3) + targetAppModel.lambda);
cfResponse = ensureReal(ifft2(sum(conj(hf) .* xtf, 3)));

% Crop square search region (in feature pixels).
cfResponse = cropFilterResponse(cfResponse, floorOdd(targetAppModel.norm_delta_area / targetAppModel.hog_cell_size));
if(targetAppModel.hog_cell_size > 1)
    % Scale up to match center likelihood resolution.
    cfResponse = mexResize(cfResponse, targetAppModel.norm_delta_area, 'auto');
end
cfResponse = double(cfResponse);