function targetAppModel = updateTargetAppModel(imgdat, targetState, targetAppModel_)

% global opts

targetCenter = targetState.targetCenter;
targetSize = targetState.targetSize;
targetAppModel = targetAppModel_;
avg_dim = sum(targetSize)/2;
bg_area = round(targetSize + avg_dim);
if(bg_area(2)>size(imgdat,2))
    bg_area(2)=size(imgdat,2)-1;
end
if(bg_area(1)>size(imgdat,1))
    bg_area(1)=size(imgdat,1)-1;
end
targetAppModel.bg_area = bg_area - mod(bg_area - targetSize, 2);
targetAppModel.fg_area = round(targetSize - avg_dim * targetAppModel.inner_padding);
targetAppModel.fg_area = targetAppModel.fg_area + mod(targetAppModel.bg_area - targetAppModel.fg_area, 2);
% Compute the rectangle with (or close to) fixed area and same aspect ratio as the target bounding box
targetAppModel.area_resize_factor = sqrt(targetAppModel.fixed_area/prod(targetAppModel.bg_area));
% extract patch of size bg_area and resize to norm_bg_area
im_patch_bg = getSubwindow(imgdat, targetCenter, targetAppModel.norm_bg_area, targetAppModel.bg_area);
% compute feature map of cf_response_size
xt = getFeatureMap(im_patch_bg, targetAppModel.cf_response_size, targetAppModel.hog_cell_size);
% apply Hann window
xt = bsxfun(@times, targetAppModel.hann_window, xt);
% compute FFT
xtf = fft2(xt);
% Compute expectations over circular shifts, therefore divide by number of pixels.
new_hf_num = bsxfun(@times, conj(targetAppModel.yf), xtf) / prod(targetAppModel.cf_response_size);
new_hf_den = (conj(xtf) .* xtf) / prod(targetAppModel.cf_response_size);
% subsequent frames, update the model by linear interpolation
targetAppModel.hf_den = (1 - targetAppModel.learning_rate_cf) * targetAppModel.hf_den + targetAppModel.learning_rate_cf * new_hf_den;
targetAppModel.hf_num = (1 - targetAppModel.learning_rate_cf) * targetAppModel.hf_num + targetAppModel.learning_rate_cf * new_hf_num;

im_patch_scale = getScaleSubwindow(imgdat, targetCenter, targetAppModel.base_target_sz, targetAppModel.scale_factor*targetAppModel.scale_factors, targetAppModel.scale_window, targetAppModel.scale_model_sz, targetAppModel.hog_scale_cell_size);
xsf = fft(im_patch_scale,[],2);
new_sf_num = bsxfun(@times, targetAppModel.ysf, conj(xsf));
new_sf_den = sum(xsf .* conj(xsf), 1);
targetAppModel.sf_den = (1 - targetAppModel.learning_rate_scale) * targetAppModel.sf_den + targetAppModel.learning_rate_scale * new_sf_den;
targetAppModel.sf_num = (1 - targetAppModel.learning_rate_scale) * targetAppModel.sf_num + targetAppModel.learning_rate_scale * new_sf_num;