function [absolutePos, relativePos] = calcPartPos(spLabel, partLabel, offset)

[height, width] = size(spLabel);
loc = zeros(height, width, 2);
[loc(:,:,1), loc(:,:,2)] = meshgrid(1:width, 1:height);

numSuperpixel = numel(partLabel);
relativePos = zeros(numSuperpixel, 2);
for i = 1:2
    temp = loc(:,:,i);
    for k = 1:numSuperpixel
        relativePos(k, i) = mean(temp(spLabel == partLabel(k)));
    end
end

absolutePos = relativePos + repmat(offset(1:2), [numSuperpixel, 1]);
