function [posLabel, negLabel, foreRatio, backRatio] = findForeSample(imgdat, spLabel, targetCenter, targetSize, bg_area, searchPos, norm_target_sz)

global opts

posFactor = opts.posnegFactor(1);
negFactor = opts.posnegFactor(2);

imageSize = size(spLabel);
% target area
xs1 = round(targetCenter(2) + (1:targetSize(2)) - targetSize(2)/2);
ys1 = round(targetCenter(1) + (1:targetSize(1)) - targetSize(1)/2);
xs1(xs1 < 1) = 1;
ys1(ys1 < 1) = 1;
xs1(xs1 > size(imgdat,2)) = size(imgdat,2);
ys1(ys1 > size(imgdat,1)) = size(imgdat,1);
im_target = imgdat(ys1, xs1, :);
[hei_t,wid_t,~] = size(im_target);
% label the foreground superpixel
xs2 = round(targetCenter(2) + (1:bg_area(2)) - bg_area(2)/2);
ys2 = round(targetCenter(1) + (1:bg_area(1)) - bg_area(1)/2);
xs2(xs2 < 1) = 1;
ys2(ys2 < 1) = 1;
xs2(xs2 > size(imgdat,2)) = size(imgdat,2);
ys2(ys2 > size(imgdat,1)) = size(imgdat,1);
im_search = imgdat(ys2, xs2, :);
[hei_s,wid_s,~] = size(im_search);
% resize the position
w_scale = imageSize(2)/wid_s;
h_scale = imageSize(1)/hei_s;
scalePos = round([(xs1(1)-searchPos(1))*w_scale,(ys1(1)-searchPos(2))*h_scale,wid_t*w_scale,hei_t*h_scale]);
foreMask = zeros(imageSize);
foreMask(max(1,scalePos(2)):min(imageSize(1),scalePos(2)+scalePos(4)-1),max(1,scalePos(1)):min(imageSize(2),scalePos(1)+scalePos(3)-1)) = 1;
foreMask = double(foreMask).*spLabel;
% figure(6),imshow(foreMask,[]);
backMask = double(foreMask==0).*spLabel;
numSuperpixel = numel(unique(spLabel));
spArea = zeros(1, numSuperpixel);
foreArea = zeros(1, numSuperpixel);
backArea = zeros(1, numSuperpixel);
foreRatio = zeros(1, numSuperpixel);
backRatio = zeros(1, numSuperpixel);
for k = 1:numSuperpixel
    spArea(k) = sum(sum(spLabel == k));
    foreArea(k) = sum(sum(foreMask == k));
    backArea(k) = sum(sum(backMask == k));  
    foreRatio(k) = posFactor*nnz(foreMask == k)/prod(norm_target_sz);
    backRatio(k) = negFactor*nnz(backMask == k)/prod(norm_target_sz);    
end
posLabel = foreArea > opts.threTrainRatio*spArea;
negLabel = backArea > opts.threTrainRatio*spArea;
if(~nnz(posLabel))
    posLabel = ~negLabel;
end