function models = proposeStructModels(targetState, searchPos, frSegment, models, extraNodes, frame)

global opts

targetCenter = targetState.targetCenter;
targetStructModel = models.targetStructModel;
spLabel = frSegment{opts.lenSegment}.spLabels.searchSpLabel;

% update the position of candidate parts
votePos = targetCenter([2 1]) - searchPos(1:2);
frSegment{opts.lenSegment}.spFeature.spSearchSeed = repmat(votePos, [numel(unique(spLabel)), 1]) + frSegment{opts.lenSegment}.spFeature.spSearchOffset;
curSegment = frSegment{opts.lenSegment};

%% graph parts birth
for i = 1:numel(extraNodes)
    canPartId = extraNodes(i);
    % if the number of nodes in graph is too large, do not create new part
    if(numel(targetStructModel.numFrPartTrack) <= 2*opts.numInitTargetParts)
        flag = true;
        for k = 1:numel(targetStructModel.numFrPartTrack)
            nodeDist = pdist2(curSegment.spFeature.spSearchSeed(canPartId, :), targetStructModel.partPos(k, :));   
            if(nodeDist <= opts.spSize)
                flag = false;
                break;
            end
        end
        if(flag)
            targetStructModel.numFrPartTrack = cat(2, targetStructModel.numFrPartTrack, frame);
            targetStructModel.partPos = cat(1, targetStructModel.partPos, curSegment.spFeature.spSearchSeed(canPartId,:));                    
            targetStructModel.partVector = cat(1, targetStructModel.partVector, curSegment.spFeature.spSearchOffset(canPartId,:));    
            targetStructModel.partFeat = cat(1, targetStructModel.partFeat, curSegment.spFeature.spSearchFeature(canPartId,:));   
            targetStructModel.partConf = cat(2, targetStructModel.partConf, curSegment.spConf(canPartId));               
        end
    end
end
targetStructModel.numParts = length(targetStructModel.numFrPartTrack);
models.targetStructModel = targetStructModel;